JACK-AUDIO-CONNECTION-KIT: Handling time

JACK-AUDIO-CONNECTION-KIT

Loading...
Searching...
No Matches
Topics | Functions | Variables
Handling time
Creating & manipulating clients » The non-callback API » Setting Client Callbacks » Controlling & querying JACK server operation » Creating & manipulating ports » Managing and determining latency » Looking up ports

## Topics
| Controlling error/information output

## Functions
jack_nframes_t | jack_frames_since_cycle_start (const jack_client_t *) JACK_OPTIONAL_WEAK_EXPORT
jack_nframes_t | jack_frame_time (const jack_client_t *) JACK_OPTIONAL_WEAK_EXPORT
jack_nframes_t | jack_last_frame_time (const jack_client_t *client) JACK_OPTIONAL_WEAK_EXPORT
int | jack_get_cycle_times (const jack_client_t *client, jack_nframes_t *current_frames, jack_time_t *current_usecs, jack_time_t *next_usecs, float *period_usecs) JACK_OPTIONAL_WEAK_EXPORT
jack_time_t | jack_frames_to_time (const jack_client_t *client, jack_nframes_t) JACK_OPTIONAL_WEAK_EXPORT
jack_nframes_t | jack_time_to_frames (const jack_client_t *client, jack_time_t) JACK_OPTIONAL_WEAK_EXPORT
jack_time_t | jack_get_time (void) JACK_OPTIONAL_WEAK_EXPORT
void | jack_set_error_function (void(*func)(const char *)) JACK_OPTIONAL_WEAK_EXPORT
void | jack_set_info_function (void(*func)(const char *)) JACK_OPTIONAL_WEAK_EXPORT
void | jack_free (void *ptr) JACK_OPTIONAL_WEAK_EXPORT

## Variables
void(* | jack_error_callback )(const char *msg) JACK_OPTIONAL_WEAK_EXPORT
void(* | jack_info_callback )(const char *msg) JACK_OPTIONAL_WEAK_EXPORT

## Detailed Description

JACK time is in units of 'frames', according to the current sample rate. The absolute value of frame times is meaningless, frame times have meaning only relative to each other.

## Function Documentation

## ◆ jack_frame_time()

jack_nframes_t jack_frame_time | ( | const jack_client_t * |  | ) |

Returns
  the estimated current time in frames. This function is intended for use in other threads (not the process callback). The return value can be compared with the value of jack_last_frame_time to relate time in other threads to JACK time.

References jack_frame_time(), and JACK_OPTIONAL_WEAK_EXPORT.

Referenced by jack_frame_time().

## ◆ jack_frames_since_cycle_start()

jack_nframes_t jack_frames_since_cycle_start | ( | const jack_client_t * |  | ) |

Returns
  the estimated time in frames that has passed since the JACK server began the current process cycle.

References jack_frames_since_cycle_start(), and JACK_OPTIONAL_WEAK_EXPORT.

Referenced by jack_frames_since_cycle_start().

## ◆ jack_frames_to_time()

jack_time_t jack_frames_to_time | ( | const jack_client_t * | client,
|  | jack_nframes_t | )

Returns
  the estimated time in microseconds of the specified frame time

References jack_frames_to_time(), and JACK_OPTIONAL_WEAK_EXPORT.

Referenced by jack_frames_to_time().

## ◆ jack_free()

void jack_free | ( | void * | ptr | ) |

The free function to be used on memory returned by jack_port_get_connections, jack_port_get_all_connections and jack_get_ports functions. This is MANDATORY on Windows when otherwise all nasty runtime version related crashes can occur. Developers are strongly encouraged to use this function instead of the standard "free" function in new code.

References jack_free(), and JACK_OPTIONAL_WEAK_EXPORT.

Referenced by jack_free().

## ◆ jack_get_cycle_times()

int jack_get_cycle_times | ( | const jack_client_t * | client,
|  | jack_nframes_t * | current_frames,
|  | jack_time_t * | current_usecs,
|  | jack_time_t * | next_usecs,
|  | float * | period_usecs )

This function may only be used from the process callback. It provides the internal cycle timing information as used by most of the other time related functions. This allows the caller to map between frame counts and microseconds with full precision (i.e. without rounding frame times to integers), and also provides e.g. the microseconds time of the start of the current cycle directly (it has to be computed otherwise).

If the return value is zero, the following information is provided in the variables pointed to by the arguments:

current_frames: the frame time counter at the start of the current cycle, same as jack_last_frame_time(). current_usecs: the microseconds time at the start of the current cycle. next_usecs: the microseconds time of the start of the next next cycle as computed by the DLL. period_usecs: the current best estimate of the period time in microseconds.

NOTES:

Because of the types used, all the returned values except period_usecs are unsigned. In computations mapping between frames and microseconds signed differences are required. The easiest way is to compute those separately and assign them to the appropriate signed variables, int32_t for frames and int64_t for usecs. See the implementation of jack_frames_to_time() and Jack_time_to_frames() for an example.

Unless there was an xrun, skipped cycles, or the current cycle is the first after freewheeling or starting Jack, the value of current_usecs will always be the value of next_usecs of the previous cycle.

The value of period_usecs will in general NOT be exactly equal to the difference of next_usecs and current_usecs. This is because to ensure stability of the DLL and continuity of the mapping, a fraction of the loop error must be included in next_usecs. For an accurate mapping between frames and microseconds, the difference of next_usecs and current_usecs should be used, and not period_usecs.

Returns
  zero if OK, non-zero otherwise.

References jack_get_cycle_times(), and JACK_OPTIONAL_WEAK_EXPORT.

Referenced by jack_get_cycle_times().

## ◆ jack_get_time()

jack_time_t jack_get_time | ( | void |  | ) |

Returns
  return JACK's current system time in microseconds, using the JACK clock source.

The value returned is guaranteed to be monotonic, but not linear.

References jack_error_callback, jack_get_time(), and JACK_OPTIONAL_WEAK_EXPORT.

Referenced by jack_get_time().

## ◆ jack_last_frame_time()

jack_nframes_t jack_last_frame_time | ( | const jack_client_t * | client | ) |

Returns
  the precise time at the start of the current process cycle. This function may only be used from the process callback, and can be used to interpret timestamps generated by jack_frame_time() in other threads with respect to the current process cycle.

This is the only jack time function that returns exact time: when used during the process callback it always returns the same value (until the next process callback, where it will return that value + nframes, etc). The return value is guaranteed to be monotonic and linear in this fashion unless an xrun occurs. If an xrun occurs, clients must check this value again, as time may have advanced in a non-linear way (e.g. cycles may have been skipped).

References jack_last_frame_time(), and JACK_OPTIONAL_WEAK_EXPORT.

Referenced by jack_last_frame_time().

## ◆ jack_set_error_function()

void jack_set_error_function | ( | void(* | func )(const char *) | ) |

Set the jack_error_callback for error message display.

The JACK library provides two built-in callbacks for this purpose: default_jack_error_callback() and silent_jack_error_callback().

References jack_info_callback, JACK_OPTIONAL_WEAK_EXPORT, and jack_set_error_function().

Referenced by jack_set_error_function().

## ◆ jack_set_info_function()

void jack_set_info_function | ( | void(* | func )(const char *) | ) |

Set the jack_info_callback for info message display.

References JACK_OPTIONAL_WEAK_EXPORT, and jack_set_info_function().

Referenced by jack_set_info_function().

## ◆ jack_time_to_frames()

jack_nframes_t jack_time_to_frames | ( | const jack_client_t * | client,
|  | jack_time_t | )

Returns
  the estimated time in frames for the specified system time.

References JACK_OPTIONAL_WEAK_EXPORT, and jack_time_to_frames().

Referenced by jack_time_to_frames().

## Variable Documentation

## ◆ jack_error_callback

void(* jack_error_callback) (const char *msg) JACK_OPTIONAL_WEAK_EXPORT | ( | const char * | msg | ) |
| extern

Display JACK error message.

Set via jack_set_error_function(), otherwise a JACK-provided default will print msg (plus a newline) to stderr.

Parameters

  msg | error message text (no newline at end).

Referenced by jack_get_time().

## ◆ jack_info_callback

void(* jack_info_callback) (const char *msg) JACK_OPTIONAL_WEAK_EXPORT | ( | const char * | msg | ) |
| extern

Display JACK info message.

Set via jack_set_info_function(), otherwise a JACK-provided default will print msg (plus a newline) to stdout.

Parameters

  msg | info message text (no newline at end).

Referenced by jack_set_error_function().